## asusctl 6.0.12

=== Makefile ===
VERSION := $(shell /usr/bin/grep -Pm1 'version = "(\d+.\d+.\d+)"' Cargo.toml | cut -d'"' -f2)

INSTALL = install
INSTALL_PROGRAM = ${INSTALL} -D -m 0755
INSTALL_DATA = ${INSTALL} -D -m 0644

prefix = /usr
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
datarootdir = $(prefix)/share
libdir = $(exec_prefix)/lib
zshcpl = $(datarootdir)/zsh/site-functions

BIN_ROG := rog-control-center
BIN_C := asusctl
BIN_D := asusd
BIN_U := asusd-user
LEDCFG := aura_support.ron

SRC := Cargo.toml Cargo.lock Makefile $(shell find -type f -wholename '**/src/*.rs')

STRIP_BINARIES ?= 0

DEBUG ?= 0
ifeq ($(DEBUG),0)
	ARGS += --release --features "rog-control-center/x11"
	TARGET = release
else
	ARGS += --profile dev --features "rog-control-center/x11"
	TARGET = debug
endif

VENDORED ?= 0
ifeq ($(VENDORED),1)
	ARGS += --frozen
endif

all: build

clean:
	cargo clean

distclean:
	rm -rf .cargo vendor vendor.tar.xz

install-program:
	$(INSTALL_PROGRAM) "./target/$(TARGET)/$(BIN_ROG)" "$(DESTDIR)$(bindir)/$(BIN_ROG)"

	$(INSTALL_PROGRAM) "./target/$(TARGET)/$(BIN_C)" "$(DESTDIR)$(bindir)/$(BIN_C)"
	$(INSTALL_PROGRAM) "./target/$(TARGET)/$(BIN_D)" "$(DESTDIR)$(bindir)/$(BIN_D)"
	$(INSTALL_PROGRAM) "./target/$(TARGET)/$(BIN_U)" "$(DESTDIR)$(bindir)/$(BIN_U)"

install-data:
	$(INSTALL_DATA) "./rog-control-center/data/$(BIN_ROG).desktop" "$(DESTDIR)$(datarootdir)/applications/$(BIN_ROG).desktop"
	$(INSTALL_DATA) "./rog-control-center/data/$(BIN_ROG).png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/$(BIN_ROG).png"
	cd rog-aura/data/layouts && find . -type f -name "*.ron" -exec $(INSTALL_DATA) "{}" "$(DESTDIR)$(datarootdir)/rog-gui/layouts/{}" \;

	$(INSTALL_DATA) "./data/$(BIN_D).rules" "$(DESTDIR)$(libdir)/udev/rules.d/99-$(BIN_D).rules"
	$(INSTALL_DATA) "./rog-aura/data/$(LEDCFG)" "$(DESTDIR)$(datarootdir)/asusd/$(LEDCFG)"
	$(INSTALL_DATA) "./data/$(BIN_D).conf" "$(DESTDIR)$(datarootdir)/dbus-1/system.d/$(BIN_D).conf"

	$(INSTALL_DATA) "./data/$(BIN_D).service" "$(DESTDIR)$(libdir)/systemd/system/$(BIN_D).service"
	$(INSTALL_DATA) "./data/$(BIN_U).service" "$(DESTDIR)$(libdir)/systemd/user/$(BIN_U).service"

	$(INSTALL_DATA) "./data/icons/asus_notif_yellow.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_yellow.png"
	$(INSTALL_DATA) "./data/icons/asus_notif_green.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_green.png"
	$(INSTALL_DATA) "./data/icons/asus_notif_blue.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_blue.png"
	$(INSTALL_DATA) "./data/icons/asus_notif_red.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_red.png"
	$(INSTALL_DATA) "./data/icons/asus_notif_orange.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_orange.png"
	$(INSTALL_DATA) "./data/icons/asus_notif_white.png" "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_white.png"

	$(INSTALL_DATA) "./data/icons/scalable/gpu-compute.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-compute.svg"
	$(INSTALL_DATA) "./data/icons/scalable/gpu-hybrid.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-hybrid.svg"
	$(INSTALL_DATA) "./data/icons/scalable/gpu-integrated.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-integrated.svg"
	$(INSTALL_DATA) "./data/icons/scalable/gpu-nvidia.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-nvidia.svg"
	$(INSTALL_DATA) "./data/icons/scalable/gpu-vfio.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-vfio.svg"
	$(INSTALL_DATA) "./data/icons/scalable/notification-reboot.svg" "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/notification-reboot.svg"

	cd rog-anime/data && find "./anime" -type f -exec $(INSTALL_DATA) "{}" "$(DESTDIR)$(datarootdir)/asusd/{}" \;

install: install-program install-data

uninstall:
	rm -f "$(DESTDIR)$(bindir)/$(BIN_ROG)"
	rm -r "$(DESTDIR)$(datarootdir)/applications/$(BIN_ROG).desktop"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/$(BIN_ROG).png"

	rm -f "$(DESTDIR)$(bindir)/$(BIN_C)"
	rm -f "$(DESTDIR)$(bindir)/$(BIN_D)"
	rm -f "$(DESTDIR)$(libdir)/udev/rules.d/99-$(BIN_D).rules"
	rm -f "$(DESTDIR)/etc/asusd/$(LEDCFG)"
	rm -f "$(DESTDIR)$(datarootdir)/dbus-1/system.d/$(BIN_D).conf"
	rm -f "$(DESTDIR)$(libdir)/systemd/system/$(BIN_D).service"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_yellow.png"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_green.png"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/512x512/apps/asus_notif_red.png"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-compute.svg"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-hybrid.svg"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-integrated.svg"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-nvidia.svg"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/gpu-vfio.svg"
	rm -r "$(DESTDIR)$(datarootdir)/icons/hicolor/scalable/status/notification-reboot.svg"
	rm -rf "$(DESTDIR)$(datarootdir)/asusd"
	rm -rf "$(DESTDIR)$(datarootdir)/rog-gui"

update:
	cargo update

vendor:
	mkdir -p .cargo
	cargo vendor | head -n -1 > .cargo/config
	echo 'directory = "vendor"' >> .cargo/config
	mv .cargo/config ./cargo-config
	rm -rf .cargo
	rm -rf vendor
	cargo vendor-filterer --all-features --platform x86_64-unknown-linux-gnu vendor
	tar pcfJ vendor_asusctl_$(VERSION).tar.xz vendor
	rm -rf vendor

bindings:
	typeshare ./rog-anime/src/ --lang=typescript --output-file=bindings/ts/anime.ts
	typeshare ./rog-aura/src/ --lang=typescript --output-file=bindings/ts/aura.ts
	typeshare ./rog-profiles/src/ --lang=typescript --output-file=bindings/ts/profiles.ts
	typeshare ./rog-platform/src/ --lang=typescript --output-file=bindings/ts/platform.ts

translate:
	find -name \*.slint | xargs slint-tr-extractor -o rog-control-center/translations/en/rog-control-center.po

build:
ifeq ($(VENDORED),1)
	cargo vendor
	@echo "version = $(VERSION)"
	tar pxf vendor_asusctl_$(VERSION).tar.xz
endif
	cargo build $(ARGS)
ifneq ($(STRIP_BINARIES),0)
	strip -s ./target/$(TARGET)/$(BIN_C)
	strip -s ./target/$(TARGET)/$(BIN_D)
	strip -s ./target/$(TARGET)/$(BIN_U)
	strip -s ./target/$(TARGET)/$(BIN_ROG)
endif


.PHONY: all clean distclean install uninstall update build bindings

=== supergfxctl/Makefile ===
VERSION := $(shell grep -Pm1 'version = "(\d.\d.\d)"' Cargo.toml | cut -d'"' -f2)

INSTALL = install
INSTALL_PROGRAM = ${INSTALL} -D -m 0755
INSTALL_DATA = ${INSTALL} -D -m 0644

prefix = /usr
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
datarootdir = $(prefix)/share
libdir = $(exec_prefix)/lib

BIN_SD := supergfxd
BIN_SC := supergfxctl
SERVICE := supergfxd.service
PRESET := supergfxd.preset
DBUSCFG := org.supergfxctl.Daemon.conf
X11CFG := 90-nvidia-screen-G05.conf
PMRULES := 90-supergfxd-nvidia-pm.rules

SRC := Cargo.toml Cargo.lock Makefile $(shell find -type f -wholename '**/src/*.rs')

DEBUG ?= 0
ifeq ($(DEBUG),0)
	ARGS += --release
	TARGET = release
endif

VENDORED ?= 0
ifeq ($(VENDORED),1)
	ARGS += --frozen
endif

all: build

clean:
	cargo clean

distclean:
	rm -rf .cargo vendor vendor-$(VERSION).tar.xz

install:
	$(INSTALL_PROGRAM) "./target/release/$(BIN_SD)" "$(DESTDIR)$(bindir)/$(BIN_SD)"
	$(INSTALL_PROGRAM) "./target/release/$(BIN_SC)" "$(DESTDIR)$(bindir)/$(BIN_SC)"
	$(INSTALL_DATA) "./data/$(SERVICE)" "$(DESTDIR)$(libdir)/systemd/system/$(SERVICE)"
	$(INSTALL_DATA) "./data/$(PRESET)" "$(DESTDIR)$(libdir)/systemd/system-preset/$(PRESET)"
	$(INSTALL_DATA) "./data/$(DBUSCFG)" "$(DESTDIR)$(datarootdir)/dbus-1/system.d/$(DBUSCFG)"
	$(INSTALL_DATA) "./data/$(X11CFG)" "$(DESTDIR)$(datarootdir)/X11/xorg.conf.d/$(X11CFG)"
	$(INSTALL_DATA) "./data/$(PMRULES)" "$(DESTDIR)$(libdir)/udev/rules.d/$(PMRULES)"

uninstall:
	rm -f "$(DESTDIR)$(bindir)/$(BIN_SC)"
	rm -f "$(DESTDIR)$(bindir)/$(BIN_SD)"
	rm -f "$(DESTDIR)$(libdir)/systemd/system/$(SERVICE)"
	rm -f "$(DESTDIR)$(libdir)/systemd/system-preset/$(PRESET)"
	rm -f "$(DESTDIR)$(datarootdir)/dbus-1/system.d/org.supergfxctl.Daemon.conf"
	rm -f "$(DESTDIR)$(datarootdir)/X11/xorg.conf.d/$(X11CFG)"
	rm -f "$(DESTDIR)$(libdir)/udev/rules.d/$(PMRULES)"

update:
	cargo update

vendor:
	mkdir -p .cargo
	cargo vendor-filterer --platform x86_64-unknown-linux-gnu vendor
	tar pcfJ vendor-$(VERSION).tar.xz vendor
	rm -rf vendor

build:
ifeq ($(VENDORED),1)
	@echo "version = $(VERSION)"
	tar pxf vendor-$(VERSION).tar.xz
endif
	cargo build --features "daemon cli" $(ARGS)
	strip -s ./target/release/$(BIN_SD)
	strip -s ./target/release/$(BIN_SC)

.PHONY: all clean distclean install uninstall update build

=== wayland-protocols-wlr/wlr-protocols/Makefile ===
PREFIX=/usr
DATADIR=$${datarootdir}
DATAROOTDIR=$${prefix}/share

unstable_protocols = \
	unstable/wlr-data-control-unstable-v1.xml \
	unstable/wlr-export-dmabuf-unstable-v1.xml \
	unstable/wlr-foreign-toplevel-management-unstable-v1.xml \
	unstable/wlr-gamma-control-unstable-v1.xml \
	unstable/wlr-input-inhibitor-unstable-v1.xml \
	unstable/wlr-layer-shell-unstable-v1.xml \
	unstable/wlr-output-management-unstable-v1.xml \
	unstable/wlr-output-power-management-unstable-v1.xml \
	unstable/wlr-screencopy-unstable-v1.xml \
	unstable/wlr-virtual-pointer-unstable-v1.xml

check: $(unstable_protocols)
	./check.sh $(unstable_protocols)

clean:
	rm -f wlr-protocols.pc

wlr-protocols.pc: wlr-protocols.pc.in
	sed \
		-e 's:@prefix@:$(PREFIX):g' \
		-e 's:@datadir@:$(DATADIR):g' \
		-e 's:@datarootdir@:$(DATAROOTDIR):g' \
		<$< >$@

install-unstable: $(unstable_protocols)
	mkdir -p $(DESTDIR)$(PREFIX)/share/wlr-protocols/unstable
	for protocol in $^ ; \
	do \
		install -Dm644 $$protocol \
			$(DESTDIR)$(PREFIX)/share/wlr-protocols/$$protocol ; \
	done

install-pc: wlr-protocols.pc
	mkdir -p $(DESTDIR)$(PREFIX)/share/pkgconfig/
	install -Dm644 wlr-protocols.pc \
		$(DESTDIR)$(PREFIX)/share/pkgconfig/wlr-protocols.pc

install: install-unstable install-pc

=== sdl2-sys/SDL/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(SDL2_test)

include(CheckCCompilerFlag)
include(CMakeParseArguments)
include(CMakePushCheckState)

set(SDL_TEST_EXECUTABLES)
set(SDL_TESTS_NONINTERACTIVE)
set(SDL_TESTS_NEEDS_ESOURCES)

macro(add_sdl_test_executable TARGET)
    cmake_parse_arguments(AST "NONINTERACTIVE;NEEDS_RESOURCES" "" "" ${ARGN})
    add_executable(${TARGET} ${AST_UNPARSED_ARGUMENTS})

    list(APPEND SDL_TEST_EXECUTABLES ${TARGET})
    if(AST_NONINTERACTIVE)
        list(APPEND SDL_TESTS_NONINTERACTIVE ${TARGET})
    endif()
    if(AST_NEEDS_RESOURCES)
        list(APPEND SDL_TESTS_NEEDS_ESOURCES ${TARGET})
    endif()
endmacro()

if(NOT TARGET SDL2::SDL2-static)
    find_package(SDL2 2.0.23 REQUIRED COMPONENTS SDL2-static SDL2test)
endif()

enable_testing()

if(SDL_INSTALL_TESTS)
    include(GNUInstallDirs)
endif()

if(N3DS)
    link_libraries(SDL2::SDL2main)
endif()

if(PSP)
    link_libraries(
        SDL2::SDL2main
        SDL2::SDL2test
        SDL2::SDL2-static
        GL
        pspvram
        pspvfpu
        pspdisplay
        pspgu
        pspge
        pspaudio
        pspctrl
        psphprm
        psppower
    )
elseif(PS2)
link_libraries(
        SDL2main
        SDL2_test
        SDL2-static
        patches
        gskit
        dmakit
        ps2_drivers
)
else()
    link_libraries(SDL2::SDL2test SDL2::SDL2-static)
endif()

if(WINDOWS)
    # mingw32 must come before SDL2main to link successfully
    if(MINGW OR CYGWIN)
        link_libraries(mingw32)
    endif()

    # CET support was added in VS 16.7
    if(MSVC_VERSION GREATER 1926 AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32|x64")
        link_libraries(-CETCOMPAT)
    endif()

    # FIXME: Parent directory CMakeLists.txt only sets these for mingw/cygwin,
    # but we need them for VS as well.
    link_libraries(SDL2main)
    add_definitions(-Dmain=SDL_main)
endif()

# CMake incorrectly detects opengl32.lib being present on MSVC ARM64
if(NOT MSVC OR NOT CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
    # Prefer GLVND, if present
    set(OpenGL_GL_PREFERENCE GLVND)
    find_package(OpenGL)
endif()

if (OPENGL_FOUND)
add_definitions(-DHAVE_OPENGL)
endif()

add_sdl_test_executable(checkkeys checkkeys.c)
add_sdl_test_executable(checkkeysthreads checkkeysthreads.c)
add_sdl_test_executable(loopwave NEEDS_RESOURCES loopwave.c testutils.c)
add_sdl_test_executable(loopwavequeue NEEDS_RESOURCES loopwavequeue.c testutils.c)
add_sdl_test_executable(testsurround testsurround.c)
add_sdl_test_executable(testresample NEEDS_RESOURCES testresample.c)
add_sdl_test_executable(testaudioinfo testaudioinfo.c)

file(GLOB TESTAUTOMATION_SOURCE_FILES testautomation*.c)
add_sdl_test_executable(testautomation NEEDS_RESOURCES ${TESTAUTOMATION_SOURCE_FILES})
add_sdl_test_executable(testmultiaudio NEEDS_RESOURCES testmultiaudio.c testutils.c)
add_sdl_test_executable(testaudiohotplug NEEDS_RESOURCES testaudiohotplug.c testutils.c)
add_sdl_test_executable(testaudiocapture testaudiocapture.c)
add_sdl_test_executable(testatomic NONINTERACTIVE testatomic.c)
add_sdl_test_executable(testintersections testintersections.c)
add_sdl_test_executable(testrelative testrelative.c)
add_sdl_test_executable(testhittesting testhittesting.c)
add_sdl_test_executable(testdraw2 testdraw2.c)
add_sdl_test_executable(testdrawchessboard testdrawchessboard.c)
add_sdl_test_executable(testdropfile testdropfile.c)
add_sdl_test_executable(testerror NONINTERACTIVE testerror.c)

if(LINUX)
    add_sdl_test_executable(testevdev NONINTERACTIVE testevdev.c)
endif()

add_sdl_test_executable(testfile testfile.c)
add_sdl_test_executable(testgamecontroller NEEDS_RESOURCES testgamecontroller.c testutils.c)
add_sdl_test_executable(testgeometry testgeometry.c testutils.c)
add_sdl_test_executable(testgesture testgesture.c)
add_sdl_test_executable(testgl2 testgl2.c)
add_sdl_test_executable(testgles testgles.c)
add_sdl_test_executable(testgles2 testgles2.c)
add_sdl_test_executable(testhaptic testhaptic.c)
add_sdl_test_executable(testhotplug testhotplug.c)
add_sdl_test_executable(testrumble testrumble.c)
add_sdl_test_executable(testthread NONINTERACTIVE testthread.c)
add_sdl_test_executable(testiconv NEEDS_RESOURCES testiconv.c testutils.c)
add_sdl_test_executable(testime NEEDS_RESOURCES testime.c testutils.c)
add_sdl_test_executable(testjoystick testjoystick.c)
add_sdl_test_executable(testkeys testkeys.c)
add_sdl_test_executable(testloadso testloadso.c)
add_sdl_test_executable(testlocale NONINTERACTIVE testlocale.c)
add_sdl_test_executable(testlock testlock.c)
add_sdl_test_executable(testmouse testmouse.c)

if(APPLE)
    add_sdl_test_executable(testnative NEEDS_RESOURCES
        testnative.c
        testnativecocoa.m
        testnativex11.c
        testutils.c
    )

    cmake_push_check_state(RESET)
    check_c_compiler_flag(-Wno-error=deprecated-declarations HAVE_WNO_ERROR_DEPRECATED_DECLARATIONS)
    cmake_pop_check_state()
    if(HAVE_WNO_ERROR_DEPRECATED_DECLARATIONS)
        set_property(SOURCE "testnativecocoa.m" APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error=deprecated-declarations")
    endif()
elseif(WINDOWS)
    add_sdl_test_executable(testnative NEEDS_RESOURCES testnative.c testnativew32.c testutils.c)
elseif(HAVE_X11)
    add_sdl_test_executable(testnative NEEDS_RESOURCES testnative.c testnativex11.c testutils.c)
    target_link_libraries(testnative X11)
endif()

add_sdl_test_executable(testoverlay2 NEEDS_RESOURCES testoverlay2.c testyuv_cvt.c testutils.c)
add_sdl_test_executable(testplatform NONINTERACTIVE testplatform.c)
add_sdl_test_executable(testpower NONINTERACTIVE testpower.c)
add_sdl_test_executable(testfilesystem NONINTERACTIVE testfilesystem.c)
add_sdl_test_executable(testrendertarget NEEDS_RESOURCES testrendertarget.c testutils.c)
add_sdl_test_executable(testscale NEEDS_RESOURCES testscale.c testutils.c)
add_sdl_test_executable(testsem testsem.c)
add_sdl_test_executable(testsensor testsensor.c)
add_sdl_test_executable(testshader NEEDS_RESOURCES testshader.c)
add_sdl_test_executable(testshape NEEDS_RESOURCES testshape.c)
add_sdl_test_executable(testsprite2 NEEDS_RESOURCES testsprite2.c testutils.c)
add_sdl_test_executable(testspriteminimal NEEDS_RESOURCES testspriteminimal.c testutils.c)
add_sdl_test_executable(teststreaming NEEDS_RESOURCES teststreaming.c testutils.c)
add_sdl_test_executable(testtimer NONINTERACTIVE testtimer.c)
add_sdl_test_executable(testurl testurl.c)
add_sdl_test_executable(testver NONINTERACTIVE testver.c)
add_sdl_test_executable(testviewport NEEDS_RESOURCES testviewport.c testutils.c)
add_sdl_test_executable(testwm2 testwm2.c)
add_sdl_test_executable(testyuv NEEDS_RESOURCES testyuv.c testyuv_cvt.c)
add_sdl_test_executable(torturethread torturethread.c)
add_sdl_test_executable(testrendercopyex NEEDS_RESOURCES testrendercopyex.c testutils.c)
add_sdl_test_executable(testmessage testmessage.c)
add_sdl_test_executable(testdisplayinfo testdisplayinfo.c)
add_sdl_test_executable(testqsort NONINTERACTIVE testqsort.c)
add_sdl_test_executable(testbounds testbounds.c)
add_sdl_test_executable(testcustomcursor testcustomcursor.c)
add_sdl_test_executable(controllermap NEEDS_RESOURCES controllermap.c testutils.c)
add_sdl_test_executable(testvulkan testvulkan.c)
add_sdl_test_executable(testoffscreen testoffscreen.c)

cmake_push_check_state(RESET)

check_c_compiler_flag(-Wformat-overflow HAVE_WFORMAT_OVERFLOW)
if(HAVE_WFORMAT_OVERFLOW)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT_OVERFLOW)
endif()

check_c_compiler_flag(-Wformat HAVE_WFORMAT)
if(HAVE_WFORMAT)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT)
endif()

check_c_compiler_flag(-Wformat-extra-args HAVE_WFORMAT_EXTRA_ARGS)
if(HAVE_WFORMAT_EXTRA_ARGS)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT_EXTRA_ARGS)
endif()

cmake_pop_check_state()

if(SDL_DUMMYAUDIO)
  list(APPEND SDL_TESTS_NONINTERACTIVE
    testaudioinfo
    testsurround
  )
endif()

if(SDL_DUMMYVIDEO)
  list(APPEND SDL_TESTS_NONINTERACTIVE
    testkeys
    testbounds
    testdisplayinfo
  )
endif()

if(OPENGL_FOUND)
    if(TARGET OpenGL::GL)
        target_link_libraries(testshader OpenGL::GL)
        target_link_libraries(testgl2 OpenGL::GL)
    else()
        if(EMSCRIPTEN AND OPENGL_gl_LIBRARY STREQUAL "nul")
            set(OPENGL_gl_LIBRARY GL)
        endif()
        # emscripten's FindOpenGL.cmake does not create OpenGL::GL
        target_link_libraries(testshader ${OPENGL_gl_LIBRARY})
        target_link_libraries(testgl2 ${OPENGL_gl_LIBRARY})
    endif()
endif()
if(EMSCRIPTEN)
    target_link_libraries(testshader -sLEGACY_GL_EMULATION)
endif()

file(GLOB RESOURCE_FILES *.bmp *.wav *.hex moose.dat utf8.txt)
file(COPY ${RESOURCE_FILES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

if(PSP)
    # Build EBOOT files if building for PSP
    set(BUILD_EBOOT
        ${SDL_TESTS_NEEDS_ESOURCES}
        testatomic
        testaudiocapture
        testaudioinfo
        testbounds
        testdisplayinfo
        testdraw2
        testdrawchessboard
        testerror
        testfile
        testfilesystem
        testgeometry
        testgl2
        testhittesting
        testiconv
        testintersections
        testjoystick
        testlock
        testmessage
        testoverlay2
        testplatform
        testpower
        testqsort
        testsem
        teststreaming
        testsurround
        testthread
        testtimer
        testver
        testviewport
        testwm2
        torturethread
    )
    foreach(APP IN LISTS BUILD_EBOOT)
        create_pbp_file(
            TARGET          ${APP}
            TITLE           SDL-${APP}
            ICON_PATH       NULL
            BACKGROUND_PATH NULL
            PREVIEW_PATH    NULL
        )
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E make_directory
            $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}
        )
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E rename
            $<TARGET_FILE_DIR:${ARG_TARGET}>/EBOOT.PBP
            $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/EBOOT.PBP
        )
        if(${BUILD_PRX})
            add_custom_command(
                TARGET ${APP} POST_BUILD
                COMMAND ${CMAKE_COMMAND} -E copy
                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}
                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}
            )
            add_custom_command(
                TARGET ${APP} POST_BUILD
                COMMAND ${CMAKE_COMMAND} -E rename
                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}.prx
                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}.prx
            )
        endif()
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E remove
            $<TARGET_FILE_DIR:${ARG_TARGET}>/PARAM.SFO
        )
    endforeach()
endif()

if(N3DS)
    set(ROMFS_DIR "${CMAKE_CURRENT_BINARY_DIR}/romfs")
    file(COPY ${RESOURCE_FILES} DESTINATION "${ROMFS_DIR}")

    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
        get_target_property(TARGET_BINARY_DIR ${APP} BINARY_DIR)
        set(SMDH_FILE "${TARGET_BINARY_DIR}/${APP}.smdh")
        ctr_generate_smdh("${SMDH_FILE}" 
            NAME "SDL-${APP}"
            DESCRIPTION "SDL2 Test suite"
            AUTHOR "SDL2 Contributors"
            ICON "${CMAKE_CURRENT_SOURCE_DIR}/n3ds/logo48x48.png"
        )
        ctr_create_3dsx(
            ${APP}
            ROMFS "${ROMFS_DIR}"
            SMDH "${SMDH_FILE}"
        )
    endforeach()
endif()

if(RISCOS)
    set(SDL_TEST_EXECUTABLES_AIF)
    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
        target_link_options(${APP} PRIVATE -static)
        add_custom_command(
            OUTPUT ${APP},ff8
            COMMAND elf2aif ${APP} ${APP},ff8
            DEPENDS ${APP}
        )
        add_custom_target(${APP}-aif ALL DEPENDS ${APP},ff8)

=== sdl2-sys/SDL/android-project/app/jni/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(GAME)

# armeabi-v7a requires cpufeatures library
# include(AndroidNdkModules)
# android_ndk_import_module_cpufeatures()


# SDL sources are in a subfolder named "SDL"
add_subdirectory(SDL)

# Compilation of companion libraries
#add_subdirectory(SDL_image)
#add_subdirectory(SDL_mixer)
#add_subdirectory(SDL_ttf)

# Your game and its CMakeLists.txt are in a subfolder named "src"
add_subdirectory(src)

=== debian/changelog ===
asusctl (6.0.12-11) plucky; urgency=medium

  * Initial version upload. (LP: #2094129)

 -- Mitchell Augustin <mitchell@mitchellaugustin.com>  Fri, 24 Jan 2025 15:33:00 -0600

=== debian/control ===
Source: asusctl
Section: utils
Priority: optional
Maintainer: Mitchell Augustin <mitchell@mitchellaugustin.com>
Uploaders: Frank Heimes <fheimes@ubuntu.com>
Build-Depends:
 cargo,
 debhelper-compat (= 13),
 dh-cargo,
 dh-exec,
 libclang-dev,
 libudev-dev,
 libfontconfig-dev,
 libxkbcommon-dev,
 libseat-dev,
 libinput-dev,
 libgbm-dev,
 cmake,
 rustc,
 libstd-rust-dev,
 quilt
Standards-Version: 4.7.0
Homepage: https://gitlab.com/asus-linux/asusctl
Rules-Requires-Root: no
XS-Build-Indep-Architecture: amd64
XS-Vendored-Sources-Rust: ab_glyph@0.2.28, ab_glyph_rasterizer@0.1.8, addr2line@0.22.0, adler2@2.0.0, adler@1.0.2, ahash@0.8.11, aho-corasick@1.1.3, allocator-api2@0.2.18, android-activity@0.6.0, android-properties@0.2.2, android-tzdata@0.1.1, android_system_properties@0.1.5, anyhow@1.0.86, arrayref@0.3.8, arrayvec@0.7.6, as-raw-xcb-connection@1.0.1, async-broadcast@0.7.1, async-channel@1.9.0, async-channel@2.3.1, async-executor@1.13.0, async-fs@1.6.0, async-fs@2.1.2, async-io@1.13.0, async-io@2.3.4, async-lock@2.8.0, async-lock@3.4.0, async-net@1.8.0, async-process@1.8.1, async-process@2.2.4, async-recursion@1.1.1, async-signal@0.2.10, async-stream-impl@0.3.5, async-stream@0.3.5, async-task@4.7.1, async-trait@0.1.81, atomic-waker@1.1.2, auto_enums@0.8.6, autocfg@1.3.0, axum-core@0.4.3, axum@0.7.5, backtrace@0.3.73, base64@0.21.7, base64@0.22.1, betrayer@0.2.0, bindgen@0.69.4, bit_field@0.10.2, bitflags@1.3.2, bitflags@2.6.0, block-buffer@0.10.4, block-sys@0.2.1, block2@0.4.0, block2@0.5.1, block@0.1.6, blocking@1.6.1, bumpalo@3.16.0, by_address@1.2.1, bytemuck@1.17.1, bytemuck_derive@1.7.1, byteorder-lite@0.1.0, byteorder@1.5.0, bytes@1.7.1, calloop-wayland-source@0.3.0, calloop@0.12.4, calloop@0.13.0, cargo-husky@1.5.0, cc@1.1.15, cesu8@1.1.0, cexpr@0.6.0, cfg-if@1.0.0, cfg_aliases@0.2.1, cgl@0.3.2, chrono@0.4.38, clang-sys@1.8.1, clipboard-win@3.1.1, clru@0.6.2, cocoa-foundation@0.1.2, cocoa@0.25.0, codemap-diagnostic@0.1.2, codemap@0.1.3, color_quant@1.1.0, combine@4.6.7, concat-idents@1.1.5, concurrent-queue@2.5.0, console-api@0.8.0, console-subscriber@0.4.0, const-field-offset-macro@0.1.5, const-field-offset@0.1.5, convert_case@0.4.0, copypasta@0.10.1, core-foundation-sys@0.8.7, core-foundation@0.9.4, core-graphics-types@0.1.3, core-graphics@0.23.2, core-text@20.1.0, countme@3.0.1, cpufeatures@0.2.13, crc32fast@1.4.2, critical-section@1.1.3, crossbeam-channel@0.5.13, crossbeam-deque@0.8.5, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.20, crunchy@0.2.2, crypto-common@0.1.6, ctor-lite@0.1.0, cursor-icon@1.1.0, data-url@0.3.1, deranged@0.3.11, derive_more@0.99.18, derive_utils@0.14.2, digest@0.10.7, dirs-next@2.0.0, dirs-sys-next@0.1.2, dirs-sys@0.3.7, dirs@4.0.0, dispatch@0.2.0, dlib@0.5.2, downcast-rs@1.2.1, dpi@0.1.1, drm-ffi@0.5.0, drm-fourcc@2.2.0, drm-sys@0.4.0, drm@0.9.0, dwrote@0.11.0, either@1.13.0, endi@1.1.0, enumflags2@0.7.10, enumflags2_derive@0.7.10, env_logger@0.10.2, equivalent@1.0.1, errno@0.3.9, euclid@0.22.11, event-listener-strategy@0.5.2, event-listener@2.5.3, event-listener@3.1.0, event-listener@5.3.1, exr@1.72.0, fastrand@1.9.0, fastrand@2.1.1, fdeflate@0.3.4, femtovg@0.9.2, field-offset@0.3.6, filetime@0.2.25, flate2@1.0.33, float-cmp@0.9.0, flume@0.11.0, fnv@1.0.7, fontconfig-parser@0.5.7, fontdb@0.18.0, fontdue@0.9.2, foreign-types-macros@0.2.3, foreign-types-shared@0.3.1, foreign-types@0.5.0, form_urlencoded@1.2.1, futures-channel@0.3.30, futures-core@0.3.30, futures-io@0.3.30, futures-lite@1.13.0, futures-lite@2.3.0, futures-sink@0.3.30, futures-task@0.3.30, futures-util@0.3.30, gbm-sys@0.2.2, gbm@0.12.0, generic-array@0.14.7, gethostname@0.4.3, getrandom@0.2.15, gettext-rs@0.7.0, gettext-sys@0.21.3, gif@0.12.0, gif@0.13.1, gimli@0.29.0, gl_generator@0.14.0, glam@0.22.0, glob@0.3.1, glow@0.13.1, glutin-winit@0.5.0, glutin@0.32.0, glutin_egl_sys@0.7.0, glutin_glx_sys@0.6.0, glutin_wgl_sys@0.6.0, gumdrop@0.8.1, gumdrop_derive@0.8.1, h2@0.4.6, half@2.4.1, hashbrown@0.12.3, hashbrown@0.14.5, hdrhistogram@7.5.4, heck@0.5.0, hermit-abi@0.3.9, hermit-abi@0.4.0, hex@0.4.3, home@0.5.9, http-body-util@0.1.2, http-body@1.0.1, http@1.1.0, httparse@1.9.4, httpdate@1.0.3, humantime@2.1.0, hyper-timeout@0.5.1, hyper-util@0.1.7, hyper@1.4.1, i-slint-backend-linuxkms@1.8.0, i-slint-backend-selector@1.8.0, i-slint-backend-winit@1.8.0, i-slint-common@1.8.0, i-slint-compiler@1.8.0, i-slint-core-macros@1.8.0, i-slint-core@1.8.0, i-slint-renderer-femtovg@1.8.0, i-slint-renderer-skia@1.8.0, iana-time-zone-haiku@0.1.2, iana-time-zone@0.1.60, icrate@0.1.2, idna@0.5.0, image@0.24.9, image@0.25.2, imagesize@0.12.0, imgref@1.10.1, indexmap@1.9.3, indexmap@2.4.0, inotify-sys@0.1.5, inotify@0.10.2, input-sys@1.18.0, input@0.8.3, instant@0.1.13, integer-sqrt@0.1.5, io-lifetimes@1.0.11, is-terminal@0.4.13, itertools@0.12.1, itertools@0.13.0, itoa@1.0.11, jni-sys@0.3.0, jni@0.21.1, jobserver@0.1.32, jpeg-decoder@0.3.1, js-sys@0.3.70, khronos_api@3.1.0, kurbo@0.11.0, lazy-bytes-cast@5.0.1, lazy_static@1.5.0, lazycell@1.3.0, lebe@0.5.2, libc@0.2.158, libloading@0.8.5, libm@0.2.8, libredox@0.0.2, libredox@0.1.3, libseat-sys@0.1.7, libseat@0.2.1, libudev-sys@0.1.4, libusb1-sys@0.7.0, linked-hash-map@0.5.6, linked_hash_set@0.1.4, linux-raw-sys@0.3.8, linux-raw-sys@0.4.14, locale_config@0.3.0, lock_api@0.4.12, log@0.4.22, logind-zbus@4.0.4, lru@0.12.4, lyon_algorithms@1.0.4, lyon_extra@1.0.2, lyon_geom@1.0.5, lyon_path@1.0.5, mac-notification-sys@0.6.1, malloc_buf@0.0.6, matchers@0.1.0, matchit@0.7.3, memchr@2.7.4, memmap2@0.8.0, memmap2@0.9.4, memoffset@0.9.1, metal@0.27.0, mime@0.3.17, minimal-lexical@0.2.1, miniz_oxide@0.4.4, miniz_oxide@0.7.4, miniz_oxide@0.8.0, mio@0.8.11, mio@1.0.2, nanorand@0.7.0, ndk-context@0.1.1, ndk-sys@0.6.0+11769913, ndk@0.9.0, nix@0.26.4, nix@0.27.1, nix@0.29.0, nom@7.1.3, notify-rust@4.11.1, num-conv@0.1.0, num-traits@0.2.19, num_enum@0.7.3, num_enum_derive@0.7.3, objc-foundation@0.1.1, objc-sys@0.3.5, objc2-app-kit@0.2.2, objc2-cloud-kit@0.2.2, objc2-contacts@0.2.2, objc2-core-data@0.2.2, objc2-core-image@0.2.2, objc2-core-location@0.2.2, objc2-encode@4.0.3, objc2-foundation@0.2.2, objc2-link-presentation@0.2.2, objc2-metal@0.2.2, objc2-quartz-core@0.2.2, objc2-symbols@0.2.2, objc2-ui-kit@0.2.2, objc2-uniform-type-identifiers@0.2.2, objc2-user-notifications@0.2.2, objc2@0.5.2, objc@0.2.7, objc_exception@0.1.2, objc_id@0.1.1, object@0.36.3, once_cell@1.19.0, orbclient@0.3.47, ordered-stream@0.2.0, owned_ttf_parser@0.24.0, parking@2.2.0, parking_lot@0.12.3, parking_lot_core@0.9.10, paste@1.0.15, percent-encoding@2.3.1, pico-args@0.5.0, pin-project-internal@1.1.5, pin-project-lite@0.2.14, pin-project@1.1.5, pin-utils@0.1.0, pin-weak@1.1.0, piper@0.2.4, pix@0.13.3, pkg-config@0.3.30, png@0.17.13, png_pong@0.8.2, polling@2.8.0, polling@3.7.3, portable-atomic@1.7.0, powerfmt@0.2.0, ppv-lite86@0.2.20, prettyplease@0.2.22, proc-macro-crate@3.2.0, proc-macro2@1.0.86, prost-derive@0.13.1, prost-types@0.13.1, prost@0.13.1, qoi@0.4.1, quick-xml@0.31.0, quick-xml@0.34.0, quote@1.0.37, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, raw-window-handle@0.6.2, rayon-core@1.12.1, rayon@1.10.0, redox_syscall@0.4.1, redox_syscall@0.5.3, redox_users@0.4.6, regex-automata@0.1.10, regex-automata@0.4.7, regex-syntax@0.6.29, regex-syntax@0.8.4, regex@1.10.6, resvg@0.42.0, rgb@0.8.48, ron@0.8.1, rowan@0.15.16, roxmltree@0.20.0, rusb@0.9.4, rustc-demangle@0.1.24, rustc-hash@1.1.0, rustc_version@0.4.1, rustix@0.37.27, rustix@0.38.35, rustversion@1.0.17, rustybuzz@0.14.1, ryu@1.0.18, same-file@1.0.6, scoped-tls-hkt@0.1.4, scoped-tls@1.0.1, scopeguard@1.2.0, sctk-adwaita@0.10.1, sdl2-sys@0.37.0, sdl2@0.37.0, semver@1.0.23, serde@1.0.209, serde_derive@1.0.209, serde_json@1.0.127, serde_repr@0.1.19, serde_spanned@0.6.7, sha1@0.10.6, sharded-slab@0.1.7, shlex@1.3.0, signal-hook-registry@1.4.2, simd-adler32@0.3.7, simplecss@0.2.1, siphasher@1.0.1, skia-bindings@0.75.0, skia-safe@0.75.0, slab@0.4.9, slint-build@1.8.0, slint-macros@1.8.0, slint@1.8.0, slotmap@1.0.7, smallvec@1.13.2, smithay-client-toolkit@0.19.2, smithay-clipboard@0.7.2, smol@1.3.0, smol_str@0.2.2, socket2@0.4.10, socket2@0.5.7, softbuffer@0.4.5, spin@0.9.8, spin_on@0.1.1, stable_deref_trait@1.2.0, static_assertions@1.1.0, strict-num@0.1.1, strum@0.26.3, strum_macros@0.26.4, supergfxctl@5.2.4, svgtypes@0.15.2, syn@1.0.109, syn@2.0.76, sync_wrapper@0.1.2, sync_wrapper@1.0.1, tar@0.4.41, tauri-winrt-notification@0.2.1, temp-dir@0.1.13, tempfile@3.12.0, termcolor@1.4.1, text-size@1.1.1, thiserror-impl@1.0.63, thiserror@1.0.63, thread_local@1.1.8, tiff@0.9.1, time-core@0.1.2, time@0.3.36, tiny-skia-path@0.11.4, tiny-skia@0.11.4, tiny-xlib@0.2.3, tinyvec@1.8.0, tinyvec_macros@0.1.1, tokio-macros@2.4.0, tokio-stream@0.1.15, tokio-util@0.7.11, tokio@1.39.3, toml@0.8.19, toml_datetime@0.6.8, toml_edit@0.22.20, tonic@0.12.2, tower-layer@0.3.3, tower-service@0.3.3, tower@0.4.13, tracing-attributes@0.1.27, tracing-core@0.1.32, tracing-subscriber@0.3.18, tracing@0.1.40, try-lock@0.2.5, ttf-parser@0.21.1, ttf-parser@0.24.1, typenum@1.17.0, typeshare-annotation@1.0.4, typeshare@1.0.3, udev@0.7.0, udev@0.8.0, udev@0.9.0, uds_windows@1.1.0, uhid-virt@0.0.7, uhidrs-sys@1.0.3, unicode-bidi-mirroring@0.2.0, unicode-bidi@0.3.15, unicode-ccc@0.2.0, unicode-ident@1.0.12, unicode-linebreak@0.1.5, unicode-normalization@0.1.23, unicode-properties@0.1.2, unicode-script@0.5.6, unicode-segmentation@1.11.0, unicode-vo@0.1.0, url@2.5.2, usvg@0.42.0, valuable@0.1.0, vcpkg@0.2.15, version-compare@0.1.1, version_check@0.9.5, versions@6.3.2, vtable-macro@0.2.0, vtable@0.2.0, waker-fn@1.2.0, walkdir@2.5.0, want@0.3.1, wasi@0.11.0+wasi-snapshot-preview1, wasm-bindgen-backend@0.2.93, wasm-bindgen-futures@0.4.43, wasm-bindgen-macro-support@0.2.93, wasm-bindgen-macro@0.2.93, wasm-bindgen-shared@0.2.93, wasm-bindgen@0.2.93, wayland-backend@0.3.6, wayland-client@0.31.5, wayland-csd-frame@0.3.0, wayland-cursor@0.31.5, wayland-protocols-plasma@0.3.3, wayland-protocols-wlr@0.3.3, wayland-protocols@0.32.3, wayland-scanner@0.31.4, wayland-sys@0.31.4, web-sys@0.3.70, web-time@1.1.0, weezl@0.1.8, which@4.4.2, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.9, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-core@0.52.0, windows-core@0.56.0, windows-implement@0.56.0, windows-interface@0.56.0, windows-result@0.1.2, windows-sys@0.45.0, windows-sys@0.48.0, windows-sys@0.52.0, windows-sys@0.59.0, windows-targets@0.42.2, windows-targets@0.48.5, windows-targets@0.52.6, windows-version@0.1.1, windows@0.56.0, windows_aarch64_gnullvm@0.42.2, windows_aarch64_gnullvm@0.48.5, windows_aarch64_gnullvm@0.52.6, windows_aarch64_msvc@0.42.2, windows_aarch64_msvc@0.48.5, windows_aarch64_msvc@0.52.6, windows_i686_gnu@0.42.2, windows_i686_gnu@0.48.5, windows_i686_gnu@0.52.6, windows_i686_gnullvm@0.52.6, windows_i686_msvc@0.42.2, windows_i686_msvc@0.48.5, windows_i686_msvc@0.52.6, windows_x86_64_gnu@0.42.2, windows_x86_64_gnu@0.48.5, windows_x86_64_gnu@0.52.6, windows_x86_64_gnullvm@0.42.2, windows_x86_64_gnullvm@0.48.5, windows_x86_64_gnullvm@0.52.6, windows_x86_64_msvc@0.42.2, windows_x86_64_msvc@0.48.5, windows_x86_64_msvc@0.52.6, winit@0.30.5, winnow@0.6.18, wio@0.2.2, x11-clipboard@0.9.2, x11-dl@2.21.0, x11rb-protocol@0.13.1, x11rb@0.13.1, xattr@1.3.1, xcursor@0.3.8, xdg-home@1.3.0, xkbcommon-dl@0.4.2, xkbcommon@0.7.0, xkeysym@0.2.1, xml-rs@0.8.21, xmlwriter@0.1.0, zbus@4.4.0, zbus_macros@4.4.0, zbus_names@3.0.0, zerocopy-derive@0.7.35, zerocopy@0.7.35, zune-inflate@0.2.54, zvariant@4.2.0, zvariant_derive@4.2.0, zvariant_utils@2.1.0
# asusctl, asusd, rog-control-center

Package: asusctl
Architecture: amd64
Priority: important
Depends:
 asusd (= 6.0.12-11),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Control fan speeds, LEDs, graphics modes, and charge levels for ASUS notebooks
 This package contains asusctl, a userspace command line utility that can
 be used to control fan curves, LEDs, graphics modes, and charge levels
 for ASUS notebooks.

Package: asusd

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home
export PKG_CONFIG_PATH = /usr/lib/x86_64-linux-gnu/pkgconfig/

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

VENDOR_TARBALL = asusctl_$(DEB_VERSION_UPSTREAM).orig-$(CARGO_VENDOR_DIR).tar.xz

vendor-tarball-sanity-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps:
	if QUILT_PATCHES=debian/patches quilt applied | grep vendor-remove-unused-deps ; then \
		echo "Detecting patch on vendor dir applied, aborting."; \
		exit 1; \
	fi
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	cargo vendor --manifest-path rust/Cargo.toml $(CARGO_VENDOR_DIR)
	# Remove some crates that aren't useful for us and take up a lot of space
	rm -r \
		$(CARGO_VENDOR_DIR)/winapi \
		$(CARGO_VENDOR_DIR)/winapi-* \
		$(CARGO_VENDOR_DIR)/windows-* \
		$(CARGO_VENDOR_DIR)/windows_* \
		$(CARGO_VENDOR_DIR)/libloading/tests/*.dll \
		# End of list
	# Remove the C sources from the binding crates, we're using the system libs
	rm -r \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib-ng \
		$(CARGO_VENDOR_DIR)/curl-sys/curl \
		# End of list
	# Remove unused and undesirable data files (e.g. test data for vendored crates)
	rm -r \
		$(CARGO_VENDOR_DIR)/vcpkg/test-data \
		$(CARGO_VENDOR_DIR)/*/tests \
		# End of list
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
	done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-sanity-check vendor-deps
	tar -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

%:
	dh $@

override_dh_auto_configure:
	tar -xvf ../$(VENDOR_TARBALL) -C .
	DEB_CARGO_CRATE=asusctl_$(shell dpkg-parsechangelog --show-field Version) \
	$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources
	dh_auto_configure

override_dh_install:
	dh_install

override_dh_installdocs:
	mv CHANGELOG.md changelog || true
	dh_installdocs

override_dh_fixperms:
	dh_fixperms

override_dh_auto_clean:
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

override_dh_builddeb:
	dh_builddeb

override_dh_clean:
	dh_clean
	rm -rf $(CARGO_HOME)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%asusctl-$1.tar.gz%" \
      https://github.com/flukejones/asusctl/tags \
      (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
